RAMSVM_linear_solve=function(x,y,k,gamma,lambda,kernel,weight,epsilon,warm)
{

y.flag=0
if (is.numeric(y)) {y.flag=1}
y.name = levels(factor(y))
y.temp = as.factor(y)
y.train = rep(0,length(y))	
for (ii in 1:k){ y.train[which(y.temp %in% y.name[ii])]=ii }
if (y.flag==1) {y.name=as.numeric(y.name)}

x.train=cbind(1,x)

ytrain=as.integer(y.train)

kdouble=k
nobs=nrow(x.train)
nobsdouble=nobs

my = t( XI.gen(k) )

yyi = Y.matrix.gen(k,nobs,y.train)

xinner = x.train %*% t(x.train)

if(is.null(warm)) {warm=matrix(0,nobs,k)}

betaout=numeric(0)

for (count in 1:length(lambda))
{
templambda = lambda[count]

alpha_ij=warm

alpha_yi=rep(0 ,nobs)

	for (zz in 1:nobs)
	{
	alpha_yi[zz] = alpha_ij[zz,y.train[zz]]
	}

erci = -diag(xinner)/2/nobs/templambda

aa = .C("alpha_update", as.vector(alpha_ij), as.vector(alpha_yi), as.vector(my), as.vector(yyi), as.vector(xinner), as.double(templambda), as.vector(weight), as.integer(nobs), as.double(nobsdouble), as.integer(k), as.double(kdouble), as.vector(erci), as.double(gamma), as.vector(ytrain), as.double(epsilon), outalpha_ij=as.vector(rep(0,nobs*k)),PACKAGE='ramsvm' )

warm=matrix(aa$outalpha_ij,nobs,k)

beta=matrix(0,ncol(x.train),(k-1))

for (q in 1:(k-1))
{
temp = rep(0,ncol(x.train))
	for (ii in 1:nobs)
	{	
		for (jj in 1:k)
		{
			if (y.train[ii] == jj)
			{
			temp = temp+warm[ii,jj]*my[jj,q]*x.train[ii,]
			}
			
			if (y.train[ii] != jj)
			{
			temp = temp-warm[ii,jj]*my[jj,q]*x.train[ii,]
			}
		}
	}


beta[,q] = temp/nobs/templambda
}


betaout=c(betaout,list(beta))

} ## for (count in 1:length(lambda))

#################################
#################################


z = list(x=x,y=y,y.name = y.name,
		k=k,gamma=gamma,weight=weight,lambda=lambda,
		kernel=kernel,beta=betaout,epsilon=epsilon,
		warm=warm)

return(z)
}
