ramsvm_linear=function(x,y,k,gamma,weight,lambda,kernel,large,epsilon,warm,nb.core)
{

if(sum(order(lambda)!=order(sort(lambda,T)))>0) {warning("The order of lambda has been changed.")}

lambda = as.double(rev(sort(lambda)))

if (!large) {z = RAMSVM_linear_solve(x,y,k,gamma,lambda,
		kernel,weight,epsilon,warm)}

if (large) {z = Large_RAMSVM_linear_solve(x,y,k,gamma,lambda,
		kernel,weight,epsilon,warm,nb.core)}

#################################
#################################
 

return(z)
}
