Large_RAMSVM_linear_solve = function(x,y,k,gamma,lambda,kernel,weight,epsilon,warm,nb.core)
{

if (is.null(nb.core)) {nb.core = detectCores()}

y.flag=0
if (is.numeric(y)) {y.flag=1}
y.name = levels(factor(y))
y.temp = as.factor(y)
y.train = rep(0,length(y))	
for (ii in 1:k){ y.train[which(y.temp %in% y.name[ii])]=ii }
if (y.flag==1) {y.name=as.numeric(y.name)}

x.train=cbind(1,x)

ytrain=as.integer(y.train)

kdouble=k
nobs=nrow(x.train)
nobsdouble=nobs

my = t( XI.gen(k) )

yyi = Y.matrix.gen(k,nobs,y.train)

xinner = x.train %*% t(x.train)

if(is.null(warm)) {warm=matrix(0,nobs,k)}

### split the data into folds ###
	 
fold = floor(min(summary(as.factor(y.train)))/30)
	 
	label.index=numeric(0)
	len=numeric(0)
	sam=numeric(0)
	for (i in 1:k)
		{
	label.index = c(label.index,list(which(y.train==i)))
	len = c(len,list(round( length(label.index[[i]])/fold )))
	sam = c(sam, list(sample(1:length(label.index[[i]])) ))
		}

betaout=numeric(0)
beta0out=numeric(0)

cl<-makeCluster(nb.core)
registerDoParallel(cl)

for (count in 1:length(lambda))
{
templambda = lambda[count]



warm2 = foreach(f_ChongZhang_f=1:fold, .combine='+') %dopar% 
{

warm3 = matrix(0,nobs,k)
     
index=numeric(0) ## which x, y weight to choose
	#####
	for (i in 1:k)
		{
	if (f_ChongZhang_f<fold)
	{
select.index = label.index[[i]][(sam[[i]])[((len[[i]]*(f_ChongZhang_f-1)+1)) : (len[[i]]*f_ChongZhang_f)]]
	}
	if (f_ChongZhang_f==fold)
	{
select.index = label.index[[i]][(sam[[i]])[((len[[i]]*(f_ChongZhang_f-1)+1)) : length(label.index[[i]])]]	
	}

index = c(index,select.index)
		}
	#####

y.train.temp = y.train[index]
nobs.temp=length(y.train.temp)
xinner.temp=xinner[index,index]
weight.temp=weight[index]
alpha_ij.temp=warm[index,]
yyi.temp=yyi[index,]
nobsdouble.temp=as.double(nobs.temp)
ytrain.temp=ytrain[index]

alpha_yi.temp=rep(0,nobs.temp)

	for (zz in 1:nobs.temp)
	{
	alpha_yi.temp[zz] = alpha_ij.temp[zz,y.train.temp[zz]]
	}
erci.temp = -diag(xinner.temp)/2/nobs.temp/templambda

aa = .C("local_alpha_update", as.vector(alpha_ij.temp), as.vector(alpha_yi.temp),
 as.vector(my), as.vector(yyi.temp), as.vector(xinner.temp),
 as.double(templambda), as.vector(weight.temp), as.integer(nobs.temp),
 as.double(nobsdouble.temp), as.integer(k), as.double(kdouble),
 as.vector(erci.temp), as.double(gamma), as.vector(ytrain.temp),outalpha_ij=as.vector(rep(0,nobs.temp*k)),PACKAGE='ramsvm' )

warm3[index,]=matrix(aa$outalpha_ij,nobs.temp,k)

warm3

} # foreach

warm=warm2


alpha_ij=warm

alpha_yi=rep(0 ,nobs)

	for (zz in 1:nobs)
	{
	alpha_yi[zz] = alpha_ij[zz,y.train[zz]]
	}

erci = -diag(xinner)/2/nobs/templambda

aa = .C("alpha_update", as.vector(alpha_ij), as.vector(alpha_yi), as.vector(my), as.vector(yyi), as.vector(xinner),
 as.double(templambda), as.vector(weight), as.integer(nobs),
 as.double(nobsdouble), as.integer(k), as.double(kdouble),
 as.vector(erci), as.double(gamma), as.vector(ytrain),as.double(epsilon), outalpha_ij=as.vector(rep(0,nobs*k)),PACKAGE='ramsvm' )

warm=matrix(aa$outalpha_ij,nobs,k)

beta=matrix(0,ncol(x.train),(k-1))

for (q in 1:(k-1))
{
temp = rep(0,ncol(x.train))
	for (ii in 1:nobs)
	{	
		for (jj in 1:k)
		{
			if (y.train[ii] == jj)
			{
			temp = temp+warm[ii,jj]*my[jj,q]*x.train[ii,]
			}
			
			if (y.train[ii] != jj)
			{
			temp = temp-warm[ii,jj]*my[jj,q]*x.train[ii,]
			}
		}
	}


beta[,q] = temp/nobs/templambda
}


betaout=c(betaout,list(beta))

} ## for (count in 1:length(lambda))

stopCluster(cl)
	
#################################

z = list(x=x,y=y,y.name = y.name,
		k=k,gamma=gamma,lambda=lambda,
		kernel=kernel,weight=weight,
		beta=betaout,epsilon=epsilon,
		warm=warm,nb.core=nb.core)

return(z)


} ## Large_RAMSVM_linear_solve
